
#
# Perl Module for EMBL::Discard
#
# Cared for by Matthew Pocock <mrp@sanger.ac.uk>
#
# Copyright Genome Research Limited (1997). Please see information on licensing in LICENSE

package EMBL::Discard;

use vars qw($AUTOLOAD @ISA @EXPORT_OK %fields);

use Exporter;
use Carp;
use strict;

use EMBL::_LineGroup;

#
# Place functions/variables you want to *export*, ie be visible from the caller package into @EXPORT_OK
#

@EXPORT_OK = qw();

BEGIN {
    @ISA = ( 'Exporter', 'EMBL::_LineGroup' );
    
    %fields = (
	       #Insert field names here as field => undef,
	       );
}

sub initialize {}

sub new {
    my $ref = shift;
    my $class = ref($ref) || $ref;
    my $self = new EMBL::_LineGroup;

    $self->rebless($class);
    return $self;
}

sub fromEMBLStream {
    my $class = shift;
    my $fh = shift;
    my $lineRef = shift;
    my $line = new EMBL::Discard;

    $$lineRef = <$fh>;
    return $line;
}

sub toEMBLStream {
    my $self = shift;
    my $fh = shift;

}


1;  # says use was ok
__END__

=head1 NAME

EMBL::Discard

=head1 DESCRIPTION

B<EMBL::Discard> discards a single line from the file,
and Prints nothing to the file.  It is inteded to be
used when you create custom parsers to allow you to easily
throw away all of the stuff that you do not wan't to look at.

=head1 AUTHOR

B<Matthew Pocock> Email mrp@sanger.ac.uk

=over

=item fromEMBLStream

Discards a line of text.  Fits API spec.

=item toEMBLStream

Prints nothing.  Fits API spec.

