
package Spangle::CGI;

use strict;
use CGI;
use Hum::Env;
use Bio::EnsEMBL::Transcript;
use Spangle::Exon;

my $SPANGLECGI = $ENV{SPANGLECGI};
my $SPANGLE    = $ENV{SPANGLE};

sub cgiscript {
  return $SPANGLECGI;
}

sub spangle {
  return $SPANGLE;
}

sub printForm {
    my ($path,$display,$file,$clone) = @_;

    printTopButton($file,$path,$display);
    
    printf($file "<INPUT type=hidden name=acepath value=$path>\n");
    printf($file "<INPUT type=hidden name=display value=\"$display\">\n");
    printf($file "<INPUT type=hidden name=clone value=\"$clone\">\n");
    
    if ($path ne "") {
      printf($file "</h2>Ace path = $path</h2>\n");
    } 

   # printf($file "This form allows you to retrieve subsequences for any clone and to
    #       find the database hits that overlap with them. The first choice allows you to
    #       enter a subsequence name directly for analysis. If the first checkbox
    #       is ticked then all the proposed genes for the input clone will be
    #       analysed.  The second option will analyse all subsequences 
    #       in the clone.  This includes FGENES and GENSCAN predicted genes.
    #       If the third checkbox is ticked then only a list 
    #       of subsequences will be output and you can manually select which subsequences
     #      to analyse. <p>\n");

    printf($file "<Table cellpadding=5 align=center width=40%><tr>\n");

    #printf($file "<td colspan=2>Enter clone/subsequence  <br><INPUT NAME=\"clone\"  size=30 value=\"$clone\"></tr>\n");    
    
    #printf($file "<tr><td align=left>\n");
    #printf($file "<INPUT type=radio name=choose value=subseq><td>Analyse above subsequence only (BROKEN!!)</tr>\n");

    printf($file "<tr><td align=left>\n");
    printf($file "<INPUT type=radio name=choose value=clone><td>Analyse all proposed genes for clone</tr>\n");

    printf($file "<tr><td align=left>\n");
    printf($file "<INPUT type=radio name=choose value=all><td>Analyse all subsequences for clone</tr>\n");

    printf($file "<tr><td align=left>\n");
    printf($file "<INPUT type=radio name=choose value=fetchsubseq><td>Fetch a list of subsequences for clone</tr>\n");

    printf($file "<input type=hidden name=evidence value=1>\n");
    printf($file "</table><p>\n");
 
    printFooter($file);

}

sub printTopButton {
  my ($file,$path,$display,$nobanner) = @_;
  printf($file "<BODY BGCOLOR=white>\n");
  
  if ($nobanner != 1) {
    printf($file "<TITLE>Humace Sequence Homology selector</TITLE>\n");
    printf($file "<table border=0 cellpadding=10 cellspacing=2><tr>");
    printf($file "<td><FORM METHOD=\"POST\" enctype='multipart/form-data' ACTION=\"$SPANGLECGI\">"); 
    printf($file "<INPUT type=submit name=action value=\"Top\">  ");
    printf($file "<td bgcolor=#5555ff><font size=+4><b>Humace Sequence Homology Selector</b></font></tr></table>\n");
    printf($file "<INPUT type=hidden name=acepath value=\"$path\">  ");
    printf($file "<INPUT type=hidden name=display value=\"$display\">  ");
    
  } else {
    printf($file "<FORM METHOD=\"POST\" enctype='multipart/form-data' ACTION=\"$SPANGLECGI\">"); 

    
    printf($file "<INPUT type=hidden name=acepath value=\"$path\">  ");
    printf($file "<INPUT type=hidden name=display value=\"$display\">  ");
  }

}

sub printHeader {
    my ($file) = @_;

#    printTopButton($file);

}

sub printFooter {
    my ($file) = @_;

    if (!defined($file)) {
      $file = \*STDOUT;
    }

    printf($file "<center>\n");
    printf($file "<INPUT TYPE=\"submit\" name=action Value=\"Submit\">\n");
    printf($file "</center><hr>\n");
}

sub print_subsequence_form {
    my ($clone,$path,$display) = @_;
    my $out;

    # Header things
    $out .= "<BODY BGCOLOR=white>\n";
    $out .= "<title>Subsequence list for "      . $clone->id  . "</title>\n";
    $out .= "<h1><center>Subsequence list for ". $clone->id  . "</center></h1>\n";
    
    $out .="<FORM METHOD=\"POST\" enctype='multipart/form-data' ACTION=\"$SPANGLECGI\"><p>\n";
    
    # Path to ace database if we're not using a server
    if ($path) {
	$out .= "<INPUT type=hidden name=acepath value=$path>\n";

    }

    if ($display) {
      $out .= "<INPUT type=hidden name=display value=\"$display\">\n";
    }
    # Submit for analysing subsequences
    $out .= "<center>\n";
    $out .= "<INPUT type=hidden name=cloneid value=" . $clone->id . ">\n";
    $out .= "<INPUT type=submit name=action value=\"Find supporting evidence\">\n";
    $out .= "<INPUT type=submit name=action value=\"Edit/create gene\">\n";
    $out .= "<INPUT type=submit name=action value=\"Make a virgin gene\">\n";
    $out .= "<INPUT type=text size=3 name=virgin_exon_number value=3>\n";
    $out .= "<INPUT type=submit name=action value=\"Fuse genes\">\n";

    $out .= "</center>\n";
    
    # Hidden variable for the clone id.

    $out .= "<INPUT type=hidden name=subseq   value=" . $clone->id .">\n";
    $out .= "<INPUT type=hidden name=genename value=" . $clone->id .">\n";
    $out .= "<INPUT type=hidden name=evidence value=1" . $clone->id .">\n";

    my @prop  = $clone->eachProposedGene;
    my @pred  = $clone->eachPredictedGene;
    my @other = $clone->eachOtherGene;

    $out .= print_gene_table("Proposed genes",\@prop);
    $out .= print_gene_table("Pseudogenes",\@other);
    $out .= print_gene_table("Predicted genes",\@pred);
    	    
    $out .= "</form>\n";

    return $out;
}

sub print_newgenes_form {

    my ($clone,$path,$display,$new,$ext,$merged) = @_;
    my $out;

    # Header things
    $out .= "<BODY BGCOLOR=white>\n";
    $out .= "<title>New genes list for "      . $clone->id  . "</title>\n";
    $out .= "<h1>New genes list for ". $clone->id  . "</h1>\n";
    
    $out .="<FORM METHOD=\"POST\" enctype='multipart/form-data' ACTION=\"$SPANGLECGI\"><p>\n";
    $out .= "<input type=hidden name=noform value=\"1\" >\n";
    # Path to ace database if we're not using a server
    if ($path) {
	$out .= "<INPUT type=hidden name=acepath value=$path>\n";
    }
    if ($display) {
	$out .= "<INPUT type=hidden name=display value=\"$display\">\n";
    }
    
    # Submit for analysing subsequences
    $out .= "<center>\n";
    $out .= "<INPUT type=submit value=\"Analyse overlapping homologies for selected subsequences\">\n";
    $out .= "</center>\n";
    
    # Hidden variable for the clone id.

    $out .= "<INPUT type=hidden name=subseq value=" . $clone->id .">\n";
    
    $out .= print_gene_table("New genes",     $new);     
    $out .= print_gene_table("Extended genes",$ext);    
    $out .= print_gene_table("Merged genes",  $merged); 
	    
    $out .= "</form>\n";

    return $out;
}

sub print_gene_table {
    my ($title,$genes) = @_;
    
    my $out;

    $out .= "<table cellpadding=2 align=center width=60%><tr><td colspan=2 valign=left><h3>$title</h3></td></tr>\n";
#    $out .= "<table cellpadding=2 align=center width=60%>\n";
 
    foreach my $g (@$genes) {
	$out .= "<TR><td width=10%><Input type=checkbox name=subseq" . 
	    $g->source_tag  . "></td> <TD>" . 
            $g->source_tag  . "</td> </tr>\n " ;
	#    $g->primary_tag . "</td></tr>\n"; redundant as it's ame as $title
    }

    $out .= "</table><p>\n";
    return $out;
}

sub writeAceFile {
    my ($gene,$path,$evidence,$type,$display) = @_;
    
    print("<BODY BGCOLOR=white><CENTER>\n");
    print("<h1>Writing supporting evidence ace file for  : $gene</h1><p>\n");
    
    
    my $file;
    my $acefile;
    my $tmp;
    
    # Choose what sort of output we want
    
    if ($path ne "") {
	if ($path !~ /\/$/) {
	    $path .= "/";
	}

	($acefile,$tmp) = get_random_httpfile("${path}rawdata/support",".ace");

	print("Ace file is $acefile<p>\n");


	open(ACE,">$acefile");

	$file = \*ACE;
	


#	print("Choose 'Read .ace file' in xace to import data<p>\n");
	
    } else {
	print("Selected supporting evidence is : <br>\n");
	$file = \*STDOUT;
    }

    
    print(($#$evidence+1) . " supporting database entries were selected<p>\n");
    
    print("<PRE>\n\n");

    printf($file "\nSequence : \"$gene\"\n");
    printf($file "-D EST_match\n");
    printf($file "-D cDNA_match\n");
    printf($file "-D Protein_match\n");

    foreach my $ev (@$evidence) {

	if ($type->{$ev} ne "") {
	    if ($ev !~ /^..:/) {
		if ($type->{$ev} eq "cDNA_match" || $type->{$ev} eq "EST_match") {
		    $ev = "Em:" . $ev;
		} elsif ($type->{$ev} eq "Protein_match") {
		    $ev = "Sw:" . $ev;
		}
	    }
	    printf($file "$type->{$ev} $ev\n");
	} else {
	    print("ERROR : no type defined for $ev\n");
	}
    }
    
    print("$path\n");
    
    if ($path ne "") {

	close($file);

	my $command = "DISPLAY=$display;export DISPLAY; xremote  -remote \' pparse $acefile ; gif ; seqget ; seqdisplay \'";
	my $out = system("$command");
      
	print("<BR><PRE>COMMAND $command</PRE>\n");
	
	printf("xace -remote return value = $out\n");

    }
    
    
    print("</PRE>\n");

}


sub get_random_httpfile{
    my ($filestub,$ext,$htstub) = @_;

    srand;    #randomize the rand
    
    my $rnd = rand;
    
    #pick the first 4 decimal places of rand to construct the tmpfile
    $rnd =~ s/0\.([0-9]{4})[0-9]*/$1/;
    my $rndfile = $filestub . $rnd . $ext;

    while (-e $rndfile) {
	$rnd = rand();
	#pick the first 4 decimal places of rand to construct the tmpfile
	$rnd =~ s/0\.([0-9]{4})[0-9]*/$1/;
	$rndfile = $filestub . $rnd . $ext;
    }
    my $htlink = $htstub . $rnd . $ext;
    return ($rndfile,$htlink);
}

sub print_gene_form {
    my ($clone,$subseq,$path,$display,$file,$subtype,$sorted) = @_;

    my $genename =  $subseq->source_tag ;

    ($clone = $genename) =~ s/(.*?)\..*/$1/;

    printf($file "<CENTER><h2>Proposed gene $genename</h2>\n");
    printf($file "<FORM METHOD=\"POST\" enctype='multipart/form-data' ACTION=\"$SPANGLECGI\">\n");
    
    printf($file "<input type=hidden name=\"genename\" value=\""  . $genename . "\">\n");
    printf($file "<input type=hidden name=\"acepath\"  value=\""  . $path     . "\">\n");
    printf($file "<input type=hidden name=\"display\"  value=\""  . $display  . "\">\n");
    printf($file "<input type=hidden name=\"noform\"   value=1>\n");
    printf($file "<input type=hidden name=\"subtype\"   value=\"" . $subtype . "\">\n");

    my $exoncount = 0;
    my $exoncountplus =1;
 
    # Start the main formatting table - the exons go in the left hand pane
    # The tags go in the right hand pane

    printf($file "<TABLE BORDER=2><TR bgcolor=cornflowerblue><TD vALIGN=top>\n");

    # Print each exon's coordinates and a select box to change things
    printf($file "<h3>Exon coordinates</h3>\n");
    my @exons = $subseq->each_Exon;

    if ($sorted == 0) {
	if ($exons[0]->strand == 1) {
        
	    @exons = sort {$a->start <=> $b->start} @exons;
	    
	    foreach my $ex (@exons) {
		printf($file "<select name=exon$exoncount size=1>\n");
		printf($file "<option selected>no change \n");
		printf($file "<option>exon before\n");
		printf($file "<option>exon after\n");
		printf($file "<option>delete\n");
		printf($file "</select>\n");
		printf($file "<input type=text size=7 name=exonstart$exoncount value=" . $ex->start . "> -"); 
		printf($file "<input type=text size=7 name=exonend$exoncount value="   . $ex->end . "> $exoncountplus<br>\n"); 
		$exoncountplus++;
		$exoncount++;
	    }
	} else {
	    @exons = sort {$b->start <=> $a->start} @exons;
	    
	    foreach my $ex (@exons) {
		printf($file "<select name=exon$exoncount size=1>\n");
		printf($file "<option selected>no change \n");
		printf($file "<option>exon before\n");
		printf($file "<option>exon after\n");
		printf($file "<option>delete\n");
		printf($file "</select>\n");
		printf($file "<input type=text size=7 name=exonend$exoncount value=" . $ex->end . "> -");
		printf($file "<input type=text size=7 name=exonstart$exoncount value="   . $ex->start . "> $exoncountplus<br>\n");
		$exoncountplus++;
		$exoncount++;
	    }
	}
    } else {
	foreach my $ex (@exons) {
	    printf($file "<select name=exon$exoncount size=1>\n");
	    printf($file "<option selected>no change \n");
	    printf($file "<option>exon before\n");
	    printf($file "<option>exon after\n");
	    printf($file "<option>delete\n");
	    printf($file "</select>\n");
	    if ($ex->strand == 1) {
		printf($file "<input type=text size=7 name=exonstart$exoncount value=" . $ex->start . "> -");
		printf($file "<input type=text size=7 name=exonend$exoncount value="   . $ex->end . "> $exoncountplus<br>\n");
	    } else {
		printf($file "<input type=text size=7 name=exonend$exoncount value=" . $ex->end . "> -");
		printf($file "<input type=text size=7 name=exonstart$exoncount value="   . $ex->start . "> $exoncountplus<br>\n");
	    }
	    $exoncountplus++;
	    $exoncount++;
	}
    }
    

    # End the left hand pane of the formatting table
    printf($file "</td><td>\n");

    my $strand                      = $subseq->strand;
    my $locus                       = $subseq->locus;
    my $start_not_found     = $subseq->start_not_found;
    my $end_not_found    = $subseq->end_not_found;
    my @remark                  = $subseq->eachRemark;
    my $note                        = $subseq->note;
    my $CDS_start               = $subseq->CDS_start;
    my $CDS_end               = $subseq->CDS_end;
    my $pseudogene              = $subseq->pseudogene;
    my $frame                       = $subseq->frame;
    
    my $locus_checked  = "checked"  if ($locus);

    $locus     = $genename unless $locus;
    #$CDS_start = 1         unless ($CDS_start ne "");

    # Now options to modify or create a new CDS/mRNA

    printf($file "<h3>Gene type</h3>\n");

    printf($file "<input type=radio name=modify      value=modify    checked> Modify existing gene <br>\n");
    printf($file "<input type=radio name=modify      value=createCDS        > Create new CDS \n");
    printf($file "<input type=text  name=newCDSname  value=$clone.          >                      <br>\n");
    printf($file "<input type=radio name=modify      value=createmRNA       > Create new mRNA\n");
    printf($file "<input type=text  name=newmRNAname value=$clone..mRNA     >                      <br>\n");

    printf($file "<p>\n");
      
    printf($file "<h3>Gene tags</h3>\n");

    # Strand
    printf($file "<select name=strand>\n");
    if ($strand == 1) { 
	printf($file "<option value=1 selected>forward</option>\n");
	printf($file "<option value=-1       >reverse</option>\n");
    }   elsif ($strand == -1) { 
	printf($file "<option value=1         >forward</option>\n");
	printf($file "<option value=-1 selected>reverse</option>\n");
    }
    printf($file "</select>\n");

    # Locus
    printf($file "<input type=checkbox name=locus     $locus_checked   > Locus \n");
    printf($file "<input type=textbox  name=locusname value=$locus     >       <br>\n");

    # Start/end not found
    my $startchecked = "checked"  if ($start_not_found);
    my $endchecked   = "checked"  if ($end_not_found);
    my $startchecked1 ="";
    my $startchecked2 ="";
    my $startchecked3 ="";

    if ($startchecked){
        if ($frame==2) {
            $startchecked2 = "checked" 
        }elsif ($frame==3) {
            $startchecked3 = "checked" 
        }else {
            $startchecked1 = "checked" 
        }
    }
    
    printf($file "<br><input type=checkbox name=start_not_found  value = 1 $startchecked > Start not found\n");
    printf($file "<input type=radio name=st_not_found    value =1 $startchecked1  > 1 ");
    printf($file "<input type=radio name=st_not_found    value =2 $startchecked2  > 2 ");
    printf($file "<input type=radio name=st_not_found    value =3 $startchecked3  > 3 <br>\n");
  
    printf($file "<input type=checkbox name=end_not_found    value = 1 $endchecked   > End not found  <br>\n");
    
    # Pseudogene
    my $pseudochecked   = "checked"  if ($pseudogene);

    printf($file "<input type=checkbox name=pseudogene  value = 1 $pseudochecked   > Pseudogene  <br>\n");

    # Coding start and end
    
    printf($file "Coding start <input type=textbox size=6 name=CDS_start value=$CDS_start> \n");
    printf($file " end <input type=textbox size=6 name=CDS_end value=$CDS_end> in global coordinates<br>\n");


    # Remark
    my $rcount = 1;
    foreach my $r (@remark) {
      printf($file "<h4>Remark $rcount</h4>\n");
      printf($file "<textarea cols = 30 rows = 1  name= remark" . ($rcount-1) . " wrap=virtual>$r");
      printf($file "</textarea><br>\n");
      $rcount++;
    }

    printf($file "</td></tr></table>\n");
    printf($file "<p>\n");
    
    # PolyA features
    
    my $polyA_site_start1;
    my $polyA_site_start2;
    my $polyA_site_start3;
    my $polyA_site_start4;
    my $polyA_signal_start1;
    my $polyA_signal_start2;
    my $polyA_signal_start3;
    my $polyA_signal_start4;
    
    printf($file "<table bgcolor=lemonchiffon>");
    printf($file "<tr><td><b>PolyA site</b> (last base)</td><td><input type=text size=6 name=polyA_site_start1 value=$polyA_site_start1></td>");
    printf($file "<td><input type=text size=6 name=polyA_site_start2 value=$polyA_site_start2>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_site_start3 value=$polyA_site_start3>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_site_start4 value=$polyA_site_start4>  </td>");
    printf($file "<tr><td><b>PolyA signal</b> (start)</td><td><input type=text size=6 name=polyA_signal_start1 value=$polyA_signal_start1></td>");
    printf($file "<td><input type=text size=6 name=polyA_signal_start2 value=$polyA_signal_start2>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_signal_start3 value=$polyA_signal_start3>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_signal_start4 value=$polyA_signal_start4>  </td>");
    printf($file "</table>\n");
    printf($file "<input type=hidden name=polyA_site1><input type=hidden name=polyA_site2><input type=hidden name=polyA_site3><input type=hidden name=polyA_site4>");
    printf($file "<input type=hidden name=polyA_signal1><input type=hidden name=polyA_signal2><input type=hidden name=polyA_signal3><input type=hidden name=polyA_signal4>");

    # Finally the footer buttons

    printf($file "<center><table border=0><tr>\n");
    printf($file "<td><INPUT name=action type=submit value=\"Update form\">");
    printf($file "<td><INPUT name=action type=submit value=\"Add remark\">");
    printf($file "<td><INPUT name=action type=submit value=\"Apply changes\">");
    printf($file "<td><INPUT name=action type=submit value=\"Find supporting evidence\"></tr></table><p>");

    printf($file "<input type=hidden name=modifygene></center>\n");
    printf($file "</form></CENTER>");
}

sub print_fusion_gene_form {
    my ($clone,$subseq,$path,$display,$file,$subtype) = @_;

  
    my $genename =  $subseq->[0]->source_tag ;
 
    ($clone = $genename) =~ s/(.*?)\..*/$1/;

 
    printf($file "<CENTER><h2>Proposed gene $genename</h2>\n");
    printf($file "<FORM METHOD=\"POST\" enctype='multipart/form-data' ACTION=\"$SPANGLECGI\">\n");
    
    printf($file "<input type=hidden name=\"genename\" value=\""  . $genename . "\">\n");
    printf($file "<input type=hidden name=\"acepath\"  value=\""  . $path     . "\">\n");
    printf($file "<input type=hidden name=\"display\"  value=\""  . $display  . "\">\n");
    printf($file "<input type=hidden name=\"noform\"   value=1>\n");
    printf($file "<input type=hidden name=\"subtype\"   value=\"" . $subtype . "\">\n");

    my $exoncount = 0;
    my $exoncountplus =1;
    
    # Start the main formatting table - the exons go in the left hand pane
    # The tags go in the right hand pane

    printf($file "<TABLE BORDER=2><TR bgcolor=cornflowerblue><TD vALIGN=top>\n");

    #sort the subsequences according to start coord (and reverse order for negative strand genes)

    my  %sortarray;
    
    foreach my $subsequence(@$subseq){
         foreach my $ex ($subsequence->each_Exon) {
            my $start=$ex->start;
            $sortarray{"$start"} = $subsequence;
            last;
         }
     }
    
    my @sortedcoords = sort {$a<=>$b} keys(%sortarray);
    if ($subseq->[0]->strand == -1){
        my @sortedcoordsrev = @sortedcoords;
        @sortedcoords = reverse(@sortedcoordsrev);
        }; 
 
   # Print each exon's coordinates and a select box to change things
    
    printf($file "<h3>Exon coordinates</h3>\n");

    foreach my $element(@sortedcoords){
          foreach  my $ex ($sortarray{$element}->each_Exon) {
	    printf($file "<select name=exon$exoncount size=1>\n");
	    printf($file "<option selected>no change \n");
	    printf($file "<option>exon before\n");
	    printf($file "<option>exon after\n");
	    printf($file "<option>delete\n");
	    printf($file "</select>\n");
	    printf($file "<input type=text size=7 name=exonstart$exoncount value=" . $ex->start . "> -"); 
	    printf($file "<input type=text size=7 name=exonend$exoncount value="   . $ex->end . "> $exoncountplus <br>\n"); 
    
	    $exoncount++;
            $exoncountplus++;
        }
    }

    # End the left hand pane of the formatting table
    printf($file "</td><td>\n");

    my $strand           = $subseq->[0]->strand;
    my $locus            = $subseq->[0]->locus;
    my $start_not_found  = $subseq->[0]->start_not_found;
    my $end_not_found    = $subseq->[0]->end_not_found;
    my @remark           = $subseq->[0]->eachRemark;
    my $note             = $subseq->[0]->note;
    my $CDS_start        = $subseq->[0]->CDS_start;
    my $pseudogene       = $subseq->[0]->pseudogene;
    
    my $locus_checked  = "checked"  if ($locus);

    $locus     = $genename unless $locus;
    $CDS_start = 1         unless ($CDS_start ne "");

    # Now options to modify or create a new CDS/mRNA

    printf($file "<h3>Gene type</h3>\n");

    printf($file "<input type=radio name=modify      value=modify    checked> Modify existing gene <br>\n");
    printf($file "<input type=radio name=modify      value=createCDS        > Create new CDS \n");
    printf($file "<input type=text  name=newCDSname  value=$clone.          >                      <br>\n");
    printf($file "<input type=radio name=modify      value=createmRNA       > Create new mRNA\n");
    printf($file "<input type=text  name=newmRNAname value=$clone..mRNA     >                      <br>\n");

    printf($file "<p>\n");
      
    printf($file "<h3>Gene tags</h3>\n");

    # Strand
    printf($file "<select name=strand>\n");
    if ($strand == 1) { 
	printf($file "<option value=1 selected>forward</option>\n");
	printf($file "<option value=-1       >reverse</option>\n");
    }   elsif ($strand == -1) { 
	printf($file "<option value=1         >forward</option>\n");
	printf($file "<option value=-1 selected>reverse</option>\n");
    }
    printf($file "</select>\n");

    # Locus
    printf($file "<input type=checkbox name=locus     $locus_checked   > Locus \n");
    printf($file "<input type=textbox  name=locusname value=$locus     >       <br>\n");

    # Start/end not found
    my $startchecked = "checked"  if ($start_not_found);
    my $endchecked   = "checked"  if ($end_not_found);

    printf($file "<input type=checkbox name=end_not_found   value = 1 $endchecked   > End not found  <br>\n");
    printf($file "<input type=checkbox name=start_not_found  value = 1 $startchecked > Start not found<br>\n");

    # Pseudogene
    my $pseudochecked   = "checked"  if ($pseudogene);

    printf($file "<input type=checkbox name=pseudogene  value = 1 $pseudochecked   > Pseudogene  <br>\n");

    # Coding start
    printf($file "Coding start <input type=textbox size=2 name=CDS_start value=$CDS_start><br>\n");

    # Remark
    my $rcount = 1;
    foreach my $r (@remark) {
      printf($file "<h4>Remark $rcount</h4>\n");
      printf($file "<textarea cols = 30 rows = 1  name= remark" . ($rcount-1) . " wrap=virtual>$r");
      printf($file "</textarea><br>\n");
      $rcount++;
    }

    printf($file "</td></tr></table>\n");
    printf($file "<p>\n");
    
    # PolyA features
    
    my $polyA_site_start1;
    my $polyA_site_start2;
    my $polyA_site_start3;
    my $polyA_site_start4;
    my $polyA_signal_start1;
    my $polyA_signal_start2;
    my $polyA_signal_start3;
    my $polyA_signal_start4;
    
    printf($file "<table bgcolor=lemonchiffon>");
    printf($file "<tr><td><b>PolyA site</b> (last base)</td><td><input type=text size=6 name=polyA_site_start1 value=$polyA_site_start1></td>");
    printf($file "<td><input type=text size=6 name=polyA_site_start2 value=$polyA_site_start2>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_site_start3 value=$polyA_site_start3>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_site_start4 value=$polyA_site_start4>  </td>");
    printf($file "<tr><td><b>PolyA signal</b> (start)</td><td><input type=text size=6 name=polyA_signal_start1 value=$polyA_signal_start1></td>");
    printf($file "<td><input type=text size=6 name=polyA_signal_start2 value=$polyA_signal_start2>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_signal_start3 value=$polyA_signal_start3>  </td>");
    printf($file "<td><input type=text size=6 name=polyA_signal_start4 value=$polyA_signal_start4>  </td>");
    printf($file "</table>\n");
    printf($file "<input type=hidden name=polyA_site1><input type=hidden name=polyA_site2><input type=hidden name=polyA_site3><input type=hidden name=polyA_site4>");
    printf($file "<input type=hidden name=polyA_signal1><input type=hidden name=polyA_signal2><input type=hidden name=polyA_signal3><input type=hidden name=polyA_signal4>");

    # Finally the footer buttons

    printf($file "<center><table border=0><tr>\n");
    printf($file "<td><INPUT name=action type=submit value=\"Update form\">");
    printf($file "<td><INPUT name=action type=submit value=\"Add remark\">");
    printf($file "<td><INPUT name=action type=submit value=\"Apply changes\">");
    printf($file "<td><INPUT name=action type=submit value=\"Find supporting evidence\"></tr></table><p>");

    printf($file "<input type=hidden name=modifygene></center>\n");
    printf($file "</form></CENTER>");
}

 




