package Jobs;


sub fork_job {
    
    my ($command,$pidfile,$timeout) = @_;
    my $pid;

    $SIG{TERM} = \&CatchSig($pid);
  
  FORK: {
      if ($pid = fork) {
	  # main thread - waits for command to finish or timeout
	 
          my $count = 0;
	  my $inc = 5;
	  
	  #wait for the pidfile to be created
	  print("Job will be killed after $timeout seconds\n");
	  sleep 5;
	  
	  # wait over timeout period or until spangle has finished
	  while (-e $pidfile && $count < $timeout) {
	      sleep $inc;
	      $count += $inc;
	  }
          
          # Another wait for the pid file to disappear
	  sleep 2;
 
	  # If pid file exists - kill process
	  if (-e $pidfile) {
	      
	      open(PID,"<$pidfile") || return "Couldn't open process id file";
	      
	      $pid = <PID>;
	      chomp($pid);
	      
	      print("Killing process ($pid) after $waittime seconds\n");
	      
	      my $result = system("kill $pid");
	      
	      system("rm $pidfile");
	      
	      close(PID);
	      
	  } elsif ($count > $timeout) {
	     print("ERROR: Process id file $pidfile doesn't exist\n");
	 } else {
	     print("successful completion of job!\n");
	 }
	  
	  
      } elsif (defined $pid) {
	  # child thread
	  
	  # Command is run here
	  my $result = system("$command");
	  
	  # Remove pidfile
	  system("rm $pidfile");
	  exit(1);
	  
      } elsif ($! =~ /No more processes/) {
	  
      } else {
	  die "Can't fork: $!\n";
	  
      }
  }
}

sub CatchSig {
  my ($name,$pid) = @_;

  #print("<br>PID for $name is $pid\n<br>");

  if (defined $pid) {
    kill('INT',$pid);

    while (($wid = wait()) != -1) {
       last if ($wid == $pid); 
    }
    $pid = undef;
  }
  return $pid;
} 
1;
