package Spangle::SeqLength_DB;

use strict;
use DB_File;

use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS $VERSION);

$VERSION = 1.00;

#my $file = "/home/michele/perl/dbmfiles/seqlength.dbm";
my $file = "/nfs/disk100/humpub/data/DBMfiles/seqlength.dbm";

sub new {
  my($class,$myfile) = @_;
  my($self);

  $self = {};

  bless $self,$class;

  $myfile = $file unless $myfile;

#  print("Sequence file is $myfile\n");

  if (! -e $myfile) {
    print("WARNING: sequence file doesn't exist\n");
  }

  $self->dbfile($myfile);

  if ( -e $myfile) {
      $self->read_DB();
  } else {
      $self->generate_DB();
  }

  return $self;
}


sub get_length {
    my ($self,$name) = @_;
    my $len = $self->_tied_hash->{$name};

    if ($len eq "") {
     $len =  $self->set_length($name);
    } 

    return $len;

}
	
sub set_length {
    my ($self,$name) = @_;
    my $len;

    eval {
      $len = `/usr/local/pubseq/bin/efetch $name 2>&1 | grep \"^ID\" `;
      if ($len eq "" && $len =~ /^EM:(.*)/) {
	(my $id = $name ) =~ s/^EM:(.*)/emnew:$1/;
	$len = `/usr/local/pubseq/bin/efetch $id | grep \"^ID\" `;
      }
      
      $len =~ s/^.* +(\d+) +...\n$/$1/;
      
      $self->_tied_hash->{$name} = $len;      
    };
    
    if (@!) {
      print("ERROR: efetch failed for $name\n");
    }

    return $len;
  }


sub read_DB {
    my ($self) = @_;
    my (%hash);
    tie %hash, "DB_File", $self->dbfile;
    $self->_tied_hash(\%hash);

}

sub generate_DB {
    my $self = shift;
    my (%hash);

   
    # Open a new db.

    tie %hash, "DB_File", $self->dbfile;

    $self->_tied_hash(\%hash);

}


sub DESTROY {
    my $self = shift;
    my $temp;

    if( defined ($temp = $self->_tied_hash) ) {
	untie(%$temp);
    }
}

=head2 _tied_hash

 Title   : _tied_hash
 Usage   : $obj->_tied_hash($newval)
 Function: 
 Example : 
 Returns : value of _tied_hash
 Args    : newvalue (optional)


=cut

sub _tied_hash{
   my ($obj,$value) = @_;
   if( defined $value) {
      $obj->{'_tied_hash'} = $value;
    }
    return $obj->{'_tied_hash'};

}

=head2 dbfile

 Title   : dbfile
 Usage   : $obj->dbfile($newval)
 Function: 
 Example : 
 Returns : value of dbfile
 Args    : newvalue (optional)


=cut

sub dbfile{
   my ($obj,$value) = @_;
   if( defined $value) {
      $obj->{'dbfile'} = $value;
    }
    return $obj->{'dbfile'};

}
	


1;
