
### Bio::EnsEMBL::Ace::Filter::GeneNew::Predicted

package Bio::EnsEMBL::Ace::Filter::Gene::Predicted;

use strict;
use Carp;
use Bio::EnsEMBL::Ace::Filter::Gene;
use vars '@ISA';
@ISA = ('Bio::EnsEMBL::Ace::Filter::Gene');

sub get_transcripts {

    my( $self, $slice ) = @_;
    my $logic_name =  $self->analysis_object->logic_name ;#'genscan';

    my $trans = $slice->get_all_PredictionTranscripts($logic_name) ;
    return $trans;
}

sub make_transcript_ace_name {
    my( $self, $transcript ) = @_;
    
    return $self->analysis_object->logic_name . '.' . $self->next_gene_int;    
}

sub CDS_start_end {
   
    my ($self , $pred_transcript , @exons_in_transcript , $slice )   = @_ ;
    
    my ( $cds_start , $cds_end );
    
    $cds_start = 1; # no?
    $cds_end = 0;   
    foreach my $exon (@exons_in_transcript){
        if ($cds_end == 0) {
#            use Data::Dumper;
#            warn Dumper($exon);
        }
        $cds_end += $exon->length ;
        #$cds_end += 0;
    }

    return($cds_start, $cds_end);
}



1;

__END__

=head1 NAME - Bio::EnsEMBL::Ace::Filter::Gene::Predicted

=head1 AUTHOR

James Gilbert B<email> jgrg@sanger.ac.uk

