### Bio::Ensembl::Ace::Ace::Filter::Similarity::DnaSimilarity

package Bio::EnsEMBL::Ace::Filter::Similarity::DnaSimilarity;

use strict;
use Carp;
use Bio::SeqIO;
use Bio::EnsEMBL::Ace::Filter::Similarity;
use Bio::EnsEMBL::Ace::Filter::Cigar_ace_parser;
use vars '@ISA'; 

@ISA = ('Bio::EnsEMBL::Ace::Filter::Similarity');



sub prepare_query{
    my ($self, $dbh) = @_ ;
    
    my $sth = $dbh->prepare(qq{
            SELECT hit_name
              , score
              , contig_start
              , contig_end
              , hit_start
              , hit_end
              , contig_strand
              , perc_ident
              , cigar_line
              , hit_strand
            FROM dna_align_feature
            WHERE contig_id = ?
              AND analysis_id = ?
            ORDER BY hit_name
              , contig_start
            });
    
    return $sth ;
} 

sub align_tag { return 'Align' };

sub is_protein { return 0 };

1;

__END__

=head1 NAME - Bio::EnsEMBL::Ace::Filter::Similarity

=head1 AUTHOR

Colin Kingswood B<email> ck2@sanger.ac.uk

